package kr.co.vividnext.sodalive.audition

import kr.co.vividnext.sodalive.common.BaseEntity
import javax.persistence.Column
import javax.persistence.Entity
import javax.persistence.EnumType
import javax.persistence.Enumerated
import javax.persistence.FetchType
import javax.persistence.JoinColumn
import javax.persistence.ManyToOne

@Entity
data class AuditionRole(
    var name: String,
    @Column(columnDefinition = "TEXT")
    var information: String,
    // 오디션 대본 URL
    var auditionScriptUrl: String? = null,
    @Enumerated(value = EnumType.STRING)
    var status: AuditionStatus = AuditionStatus.IN_PROGRESS
) : BaseEntity() {
    var isActive: Boolean = true
    var imagePath: String? = null

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "audition_id", nullable = false)
    var audition: Audition? = null
}
