package kr.co.vividnext.sodalive.explorer.section

import kr.co.vividnext.sodalive.common.BaseEntity
import kr.co.vividnext.sodalive.member.tag.CreatorTag
import javax.persistence.CascadeType
import javax.persistence.Column
import javax.persistence.Entity
import javax.persistence.FetchType
import javax.persistence.JoinColumn
import javax.persistence.ManyToOne
import javax.persistence.OneToMany

@Entity
data class ExplorerSection(
    var title: String,
    var isAdult: Boolean,
    @Column(nullable = false)
    var orders: Int = 1
) : BaseEntity() {

    @Column(nullable = true)
    var coloredTitle: String? = null

    @Column(nullable = true)
    var color: String? = null

    @Column(nullable = false)
    var isActive: Boolean = true

    @OneToMany(mappedBy = "explorerSection", cascade = [CascadeType.ALL], orphanRemoval = true)
    var tags: MutableList<ExplorerSectionCreatorTag> = mutableListOf()
}

@Entity
class ExplorerSectionCreatorTag : BaseEntity() {
    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "explorer_section_id", nullable = false)
    var explorerSection: ExplorerSection? = null

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "creator_tag_id", nullable = false)
    var tag: CreatorTag? = null
}
