package kr.co.vividnext.sodalive.google

import com.google.api.services.androidpublisher.AndroidPublisher
import com.google.api.services.androidpublisher.model.ProductPurchasesAcknowledgeRequest
import org.springframework.stereotype.Service

@Service
class GooglePlayService(private val androidPublisher: AndroidPublisher) {
    fun verifyAndConsumePurchase(purchaseToken: String, productId: String): String {
        val packageName = "kr.co.vividnext.sodalive"
        val purchase = androidPublisher.purchases().products().get(packageName, productId, purchaseToken).execute()

        if (purchase.purchaseState == 0 && purchase.acknowledgementState == 0) {
            val request = ProductPurchasesAcknowledgeRequest()
            androidPublisher.purchases().products()
                .acknowledge(packageName, productId, purchaseToken, request)
                .execute()

            androidPublisher.purchases().products().consume(packageName, productId, purchaseToken).execute()
            return purchase.orderId
        }

        return ""
    }
}
