package kr.co.vividnext.sodalive.marketing

import kr.co.vividnext.sodalive.common.ApiResponse
import org.springframework.web.bind.annotation.PostMapping
import org.springframework.web.bind.annotation.RequestBody
import org.springframework.web.bind.annotation.RequestMapping
import org.springframework.web.bind.annotation.RestController

@RestController
@RequestMapping("/ad-tracking")
class AdTrackingController(private val service: AdTrackingService) {
    @PostMapping("/app-launch")
    fun trackingAppLaunch(
        @RequestBody request: AdTrackingAppLaunchRequest
    ) = run {
        ApiResponse.ok(
            service.saveTrackingHistory(
                pid = request.pid,
                type = AdTrackingHistoryType.APP_LAUNCH,
                memberId = 0,
                price = null,
                locale = null
            )
        )
    }
}
