package kr.co.vividnext.sodalive.member.following

import kr.co.vividnext.sodalive.common.BaseEntity
import kr.co.vividnext.sodalive.member.Member
import javax.persistence.Entity
import javax.persistence.FetchType
import javax.persistence.JoinColumn
import javax.persistence.ManyToOne

@Entity
data class CreatorFollowing(
    var isNotify: Boolean = true,
    var isActive: Boolean = true
) : BaseEntity() {
    // 유저가 알림받기 한 크리에이터
    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "creator_id", nullable = false)
    var creator: Member? = null

    // 크리에이터를 알림받기 한 유저
    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "member_id", nullable = false)
    var member: Member? = null
}
