package kr.co.vividnext.sodalive.menu

import kr.co.vividnext.sodalive.common.SodaException
import kr.co.vividnext.sodalive.member.MemberRepository
import org.springframework.security.core.userdetails.User
import org.springframework.stereotype.Service

@Service
class MenuService(
    private val repository: MenuRepository,
    private val memberRepository: MemberRepository
) {
    fun getMenus(user: User): List<GetMenuResponse> {
        val member = memberRepository.findByEmail(user.username)
            ?: throw SodaException("로그인 정보를 확인해주세요.")
        return repository.getMenu(member.role)
    }
}
