package kr.co.vividnext.sodalive.report

import kr.co.vividnext.sodalive.common.BaseEntity
import kr.co.vividnext.sodalive.explorer.profile.CreatorCheers
import kr.co.vividnext.sodalive.explorer.profile.creatorCommunity.CreatorCommunity
import kr.co.vividnext.sodalive.member.Member
import javax.persistence.Entity
import javax.persistence.EnumType
import javax.persistence.Enumerated
import javax.persistence.FetchType
import javax.persistence.JoinColumn
import javax.persistence.ManyToOne

@Entity
data class Report(
    @Enumerated(value = EnumType.STRING)
    val type: ReportType,
    val reason: String
) : BaseEntity() {
    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "member_id", nullable = false)
    var member: Member? = null

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "reported_member_id", nullable = true)
    var reportedAccount: Member? = null

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "cheers_id", nullable = true)
    var cheers: CreatorCheers? = null

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "community_post_id", nullable = true)
    var communityPost: CreatorCommunity? = null
}

enum class ReportType {
    PROFILE, USER, CHEERS, AUDIO_CONTENT, COMMUNITY_POST
}
